=== docs/requirements.txt ===
docutils<0.18
matplotlib
