=== debian/changelog ===
amgcl (1.4.3-5build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 18:54:47 +0000

amgcl (1.4.3-5) unstable; urgency=medium

  * Fixed build on 32-bit platforms. Again. (Closes: #1020834)

 -- Dima Kogan <dkogan@debian.org>  Mon, 02 Jan 2023 22:28:19 -0800

amgcl (1.4.3-4) unstable; urgency=medium

  * Fixed build on 32-bit platforms (Closes: #1020834)

 -- Dima Kogan <dkogan@debian.org>  Mon, 19 Dec 2022 20:37:12 -0800

amgcl (1.4.3-3) unstable; urgency=medium

  * Build-Depends: python3-dev, not python3-all-dev (Closes: #1024313)

 -- Dima Kogan <dkogan@debian.org>  Sat, 19 Nov 2022 14:47:54 -0800

amgcl (1.4.3-2) unstable; urgency=medium

  * More explicit copyright notes
  * This project is in contrib

 -- Dima Kogan <dkogan@debian.org>  Fri, 12 Aug 2022 20:37:29 -0700

amgcl (1.4.3-1) unstable; urgency=medium

  * Initial upload into Debian (Closes: #1015820)

 -- Dima Kogan <dkogan@debian.org>  Thu, 21 Jul 2022 13:29:17 -0700
