=== debian/watch ===
version=4
https://github.com/ddemidov/amgcl/tags .*/?(\d\S+)\.tar\.gz
