## amgcl 1.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
     set(Boost_USE_STATIC_LIBS ON)
 endif ()
 
-find_package(Boost REQUIRED COMPONENTS
+find_package(Boost COMPONENTS
     program_options
     serialization
     unit_test_framework
@@ -48,9 +48,13 @@
     cxx_static_assert
 )
 
-target_include_directories(amgcl SYSTEM INTERFACE
-    ${Boost_INCLUDE_DIRS}
-    )
+if (Boost_FOUND)
+    target_include_directories(amgcl SYSTEM INTERFACE
+        ${Boost_INCLUDE_DIRS}
+        )
+else()
+    target_compile_definitions(amgcl INTERFACE AMGCL_NO_BOOST)
+endif()
 
 target_include_directories(amgcl INTERFACE
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
@@ -117,7 +121,9 @@
 #----------------------------------------------------------------------------
 # Find VexCL
 #----------------------------------------------------------------------------
-find_package(VexCL QUIET)
+if (Boost_FOUND)
+    find_package(VexCL QUIET)
+endif()
 
 #----------------------------------------------------------------------------
 # Find ViennaCL
@@ -226,8 +232,11 @@
 endif()
 
 if (AMGCL_MASTER_PROJECT)
-    option(AMGCL_BUILD_TESTS    OFF)
-    option(AMGCL_BUILD_EXAMPLES OFF)
+    if (Boost_FOUND)
+        option(AMGCL_BUILD_TESTS    OFF)
+        option(AMGCL_BUILD_EXAMPLES OFF)
+    endif()
+
     option(AMGCL_DISABLE_RARE_COMPONENTS OFF)
 
     if(AMGCL_DISABLE_RARE_COMPONENTS)
