=== tutorial/CMakeLists.txt ===
add_subdirectory(1.poisson3Db)
add_subdirectory(2.Serena)
add_subdirectory(3.CoupCons3D)
add_subdirectory(4.Stokes)
add_subdirectory(5.Nullspace)
