=== debian/changelog ===
amgcl (1.4.4-1) unstable; urgency=medium

  * New upstream release
  * Fixed build with scipy 1.14 (Closes: #1090190)

 -- Dima Kogan <dkogan@debian.org>  Mon, 13 Jan 2025 21:42:55 -0800

amgcl (1.4.3-7) unstable; urgency=medium

  * Added Build-Depends:python3-setuptools (Closes: #1080534)

 -- Dima Kogan <dkogan@debian.org>  Fri, 06 Sep 2024 13:18:08 -0700

amgcl (1.4.3-6) unstable; urgency=medium

  * Rebuild for python 3.12

 -- Dima Kogan <dkogan@debian.org>  Tue, 25 Jun 2024 20:54:38 -0700
