=== debian/control ===
Source: amgcl
Section: contrib/libdevel
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-test-dev,
               libboost-serialization-dev,
               libboost-program-options-dev,
               libeigen3-dev,
               libviennacl-dev,
               libopenmpi-dev,
               libmetis-dev,
               libparmetis-dev,
               libblas-dev,
               libscotch-dev,
               libbz2-dev,
               libhwloc-dev,
               gfortran,
               dh-python,
# for "make install" to work. See
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080534
               python3-setuptools,
               pybind11-dev,
               python3-dev:any,
               libpython3-dev,
# These are for the tests only
               python3-numpy <!nocheck>,
               python3-scipy <!nocheck>
Standards-Version: 4.6.0
Homepage: https://github.com/ddemidov/amgcl
Vcs-Git: https://salsa.debian.org/science-team/amgcl.git
Vcs-Browser: https://salsa.debian.org/science-team/amgcl

Package: libamgcl-dev
Architecture: all
Depends: ${misc:Depends},
Description: Solves large sparse linear systems with algebraic multigrid method
 AMG is one of the most effective iterative methods for solution of equation
 systems arising, for example, from discretizing PDEs on unstructured grids. The
 method can be used as a black-box solver for various computational problems,
 since it does not require any information about the underlying geometry. AMG is
 often used not as a standalone solver but as a preconditioner within an
 iterative solver (e.g. Conjugate Gradients, BiCGStab, or GMRES).
 .
 AMGCL builds the AMG hierarchy on a CPU and then transfers it to one of the
 provided backends. This allows for transparent acceleration of the solution
 phase with help of OpenCL, CUDA, or OpenMP technologies. Users may provide
 their own backends which enables tight integration between AMGCL and the user
 code.
 .
 AMG is a header-only C++ library, with the headers provided by this package.

Package: python3-amgcl
Section: contrib/python
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
         ${python3:Depends}
Provides: ${python3:Provides}
Description: Solves large sparse linear systems with algebraic multigrid method
 AMG is one of the most effective iterative methods for solution of equation
 systems arising, for example, from discretizing PDEs on unstructured grids. The
 method can be used as a black-box solver for various computational problems,
 since it does not require any information about the underlying geometry. AMG is
 often used not as a standalone solver but as a preconditioner within an
 iterative solver (e.g. Conjugate Gradients, BiCGStab, or GMRES).
 .
 AMGCL builds the AMG hierarchy on a CPU and then transfers it to one of the
 provided backends. This allows for transparent acceleration of the solution
 phase with help of OpenCL, CUDA, or OpenMP technologies. Users may provide
 their own backends which enables tight integration between AMGCL and the user
 code.
 .
 This package provides the Python interface
