=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DAMGCL_BUILD_TESTS=ON \
		-DAMGCL_BUILD_EXAMPLES=ON \
		-DAMGCL_DISABLE_RARE_COMPONENTS=OFF \
		-DAMGCL_HAVE_PYTHON=ON \
		-DAMGCL_HAVE_FORTRAN=ON

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	mkdir -p debian/tmp/usr/lib/python3/dist-packages/pyamgcl
	cp obj-*/pyamgcl/pyamgcl_ext.cpython-*.so debian/tmp/usr/lib/python3/dist-packages/pyamgcl
	cp pyamgcl/__init__.py                    debian/tmp/usr/lib/python3/dist-packages/pyamgcl

override_dh_installdocs:
	dh_installdocs -X.git\*
